
--  ========================================================
--  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

--  SCHEMA PRODUCTEUR CONSOMMATEUR IMPLANTE PAR UN OBJET PROTEGE
--  paquetage de realisation : .adb
--  =============================================


package body Stock is
   N : constant := 8;
   type Index is mod N;
   type Tab_Mess is array (Index) of Message;

   protected Tampon is
      entry Poser_Un (X : in Message);
      entry Tirer_Un (X : out Message);
      entry Poser_Deux (X, Y : in Message);
      entry Tirer_Deux (X, Y : out Message);
      entry Poser (Z : in Tab_Message);
      entry Tirer (Z : out Tab_Message);
   private
      A : Tab_Mess;
      T, Q : Index := Index'First;
      Nombre : Integer range 0 .. N := 0;
      entry Poser_Bis (Z : in Tab_Message);
      entry Tirer_Bis (Z : out Tab_Message);
   end Tampon;

   protected body Tampon is
      entry Poser_Un (X : in Message) when Nombre < N is
         --  variante when Nombre < N and Poser_Deux'Count = 0 is
      begin
         A (Q) := X;
         Q := Q + 1; Nombre := Nombre + 1;
      end Poser_Un;

      entry Tirer_Un (X : out Message) when Nombre > 0 is
         --  variante when Nombre > 0 and Tirer_Deux'Count = 0 is
      begin
         X := A (T);
         T := T + 1; Nombre := Nombre - 1;
      end Tirer_Un;

      entry Poser_Deux (X, Y : in Message) when Nombre < N - 1 is
      begin
         null;
      end Poser_Deux;

      entry Tirer_Deux (X, Y : out Message)  when Nombre > 1 is
      begin
        null;
      end Tirer_Deux;

      entry Poser (Z : in Tab_Message) when Nombre < N is
      begin
         null;
      end Poser;

      entry Poser_Bis (Z : in Tab_Message) when Nombre < N is
      begin
         null;
      end Poser_Bis;

      entry Tirer (Z : out Tab_Message)  when Nombre > 0 is
      begin
        null;
      end Tirer;

      entry Tirer_Bis (Z : out Tab_Message)  when Nombre > 0 is
      begin
         null;
      end Tirer_Bis;

   end Tampon;

   procedure Deposer_Un (X : in Message) is
   begin
      Tampon.Poser_Un (X);
   end Deposer_Un;

   procedure Retirer_Un (X : out Message) is
   begin
      Tampon.Tirer_Un (X);
   end Retirer_Un;

   procedure Deposer_Deux (X, Y : in Message) is
   begin
      Tampon.Poser_Deux (X, Y);
   end Deposer_Deux;

   procedure Retirer_Deux (X, Y : out Message)  is
   begin
      Tampon.Tirer_Deux (X, Y);
   end Retirer_Deux;

   procedure Deposer (Z : in Tab_Message) is
   begin
      Tampon.Poser (Z);
   end Deposer;

   procedure Retirer (Z : out Tab_Message) is
   begin
      Tampon.Tirer (Z);
   end Retirer;

end Stock;
