
--  ========================================================
--  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

--  SCHEMA PRODUCTEUR CONSOMMATEUR IMPLANTE PAR UN OBJET PROTEGE
--  programme principal: .ads
--  =============================================

with Global; use Global;
with Stock; use Stock;
with Ada.Text_IO; use  Ada.Text_IO;
with Ada.Exceptions; use Ada.Exceptions;

procedure Prod_Cons is
   task Premier_Producteur; task Second_Producteur;
  task Second_Consommateur; task Premier_Consommateur; 

   task body Premier_Producteur is
      M : Message;
      Mon_Message : Tab_Message (1 .. 1);
   begin
      for I in 1 .. 16 loop
         M := Message (I);
         Put_Line ("Le Premier_Producteur envoie " & Message'Image (M));
         Deposer_Un (M);
         Put_Line ("Le Premier_Producteur envoie a nouveau " & Message'Image (M));
         Mon_Message (1) := M;
         Deposer (Mon_Message);
      end loop;
      Put_Line ("Le Premier_Producteur a fini");
   exception
      when others =>
         Put_Line ("Erreur dans premier prod");
   end Premier_Producteur;

   task body Second_Producteur is
      M, N : Message;
      Mon_Message : Tab_Message (1 .. 2);
   begin
      for I in 1 .. 16 loop
         M := Message (I);
         N := 2*Message (I);
         Put_Line ("Le second_Producteur envoie " & Message'Image (M) & Message'Image (N));
         Deposer_Deux (M, N);
         Put_Line ("Le second_Producteur envoie a nouveau " & Message'Image (M) & Message'Image (N));
         Mon_Message (1) := M; Mon_Message (2) := N;
         Deposer (Mon_Message);
      end loop;
      Put_Line ("Le Second_Producteur a fini");
   exception
      when others =>
         Put_Line ("Erreur dans second prod");
   end Second_Producteur;

   task body Second_Consommateur is
      M, N : Message;
      Mon_Message : Tab_Message (1 .. 2);
   begin
      for I in 1 .. 16 loop
         Retirer_Deux (M, N);
         Put_Line ("Le Second_Consommateur a recu " & Message'Image (M) & Message'Image (N));
         Retirer (Mon_Message); M := Mon_Message (1); N := Mon_Message (2);
         Put_Line ("Le second_Consommateur a recu autrement " & Message'Image (M) & Message'Image (N));
      end loop;
      Put_Line ("Le second_Consommateur a fini");
   exception
      when others =>
         Put_Line ("Erreur dans second cons");
   end Second_Consommateur;
   
    task body Premier_Consommateur is
      M : Message;
      Mon_Message : Tab_Message (1 .. 1);
   begin
      for I in 1 .. 16 loop
         Retirer_Un (M);
         Put_Line ("Le Premier_Consommateur a recu " & Message'Image (M));
         Retirer (Mon_Message);
         M := Mon_Message (1);
         Put_Line ("Le Premier_Consommateur a recu autrement " & Message'Image (M));
      end loop;
      Put_Line ("Le Premier_Consommateur a fini");
   exception
      when The_Error : others =>
         Put_Line (Ada.Exceptions.Exception_Name (The_Error));
         Put_Line (Ada.Exceptions.Exception_Message (The_Error));
         Put_Line ("Erreur dans premier cons");
   end Premier_Consommateur;

begin
   null;
end Prod_Cons;
